
Efl_Object *_efl_thread_efl_object_constructor(Eo *obj, Efl_Thread_Data *pd);


Efl_Object *_efl_thread_efl_object_finalize(Eo *obj, Efl_Thread_Data *pd);


void _efl_thread_efl_object_destructor(Eo *obj, Efl_Thread_Data *pd);


void _efl_thread_efl_object_parent_set(Eo *obj, Efl_Thread_Data *pd, Efl_Object *parent);


Eina_Bool _efl_thread_efl_task_run(Eo *obj, Efl_Thread_Data *pd);


void _efl_thread_efl_task_end(Eo *obj, Efl_Thread_Data *pd);


Eina_Error _efl_thread_efl_io_closer_close(Eo *obj, Efl_Thread_Data *pd);


Eina_Bool _efl_thread_efl_io_closer_closed_get(const Eo *obj, Efl_Thread_Data *pd);


Eina_Error _efl_thread_efl_io_reader_read(Eo *obj, Efl_Thread_Data *pd, Eina_Rw_Slice *rw_slice);


void _efl_thread_efl_io_reader_can_read_set(Eo *obj, Efl_Thread_Data *pd, Eina_Bool can_read);


Eina_Bool _efl_thread_efl_io_reader_can_read_get(const Eo *obj, Efl_Thread_Data *pd);


void _efl_thread_efl_io_reader_eos_set(Eo *obj, Efl_Thread_Data *pd, Eina_Bool is_eos);


Eina_Bool _efl_thread_efl_io_reader_eos_get(const Eo *obj, Efl_Thread_Data *pd);


Eina_Error _efl_thread_efl_io_writer_write(Eo *obj, Efl_Thread_Data *pd, Eina_Slice *slice, Eina_Slice *remaining);


void _efl_thread_efl_io_writer_can_write_set(Eo *obj, Efl_Thread_Data *pd, Eina_Bool can_write);


Eina_Bool _efl_thread_efl_io_writer_can_write_get(const Eo *obj, Efl_Thread_Data *pd);


void _efl_thread_efl_threadio_call(Eo *obj, Efl_Thread_Data *pd, void *func_data, EflThreadIOCall func, Eina_Free_Cb func_free_cb);


void *_efl_thread_efl_threadio_call_sync(Eo *obj, Efl_Thread_Data *pd, void *func_data, EflThreadIOCallSync func, Eina_Free_Cb func_free_cb);


static Eina_Bool
_efl_thread_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_THREAD_EXTRA_OPS
#define EFL_THREAD_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_thread_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_finalize, _efl_thread_efl_object_finalize),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_thread_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_parent_set, _efl_thread_efl_object_parent_set),
      EFL_OBJECT_OP_FUNC(efl_task_run, _efl_thread_efl_task_run),
      EFL_OBJECT_OP_FUNC(efl_task_end, _efl_thread_efl_task_end),
      EFL_OBJECT_OP_FUNC(efl_io_closer_close, _efl_thread_efl_io_closer_close),
      EFL_OBJECT_OP_FUNC(efl_io_closer_closed_get, _efl_thread_efl_io_closer_closed_get),
      EFL_OBJECT_OP_FUNC(efl_io_reader_read, _efl_thread_efl_io_reader_read),
      EFL_OBJECT_OP_FUNC(efl_io_reader_can_read_set, _efl_thread_efl_io_reader_can_read_set),
      EFL_OBJECT_OP_FUNC(efl_io_reader_can_read_get, _efl_thread_efl_io_reader_can_read_get),
      EFL_OBJECT_OP_FUNC(efl_io_reader_eos_set, _efl_thread_efl_io_reader_eos_set),
      EFL_OBJECT_OP_FUNC(efl_io_reader_eos_get, _efl_thread_efl_io_reader_eos_get),
      EFL_OBJECT_OP_FUNC(efl_io_writer_write, _efl_thread_efl_io_writer_write),
      EFL_OBJECT_OP_FUNC(efl_io_writer_can_write_set, _efl_thread_efl_io_writer_can_write_set),
      EFL_OBJECT_OP_FUNC(efl_io_writer_can_write_get, _efl_thread_efl_io_writer_can_write_get),
      EFL_OBJECT_OP_FUNC(efl_threadio_call, _efl_thread_efl_threadio_call),
      EFL_OBJECT_OP_FUNC(efl_threadio_call_sync, _efl_thread_efl_threadio_call_sync),
      EFL_THREAD_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_thread_class_desc = {
   EO_VERSION,
   "Efl.Thread",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Thread_Data),
   _efl_thread_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_thread_class_get, &_efl_thread_class_desc, EFL_TASK_CLASS, EFL_THREADIO_MIXIN, EFL_IO_READER_INTERFACE, EFL_IO_WRITER_INTERFACE, EFL_IO_CLOSER_INTERFACE, EFL_CORE_COMMAND_LINE_MIXIN, NULL);
